byte sem = 1;
byte critical = 0; /* ghost variable
                      for verification only */

active [3] proctype P() {
  do ::
        printf("Non critical section P\n");
        /* begin critical section */
        atomic { /* "wait(sem)" */
          sem > 0;
          sem-- 
        }
        critical++;
        assert (critical <= 1);
        critical--;
        printf("Critical section P\n");
        sem++    /* "signal(sem)" */
        /* end critical section */
  od
}

